import java.awt.*;
import java.applet.*;
public class atomTest
{
    /*________________________________
    ___________Variable_____________*/
    pigFunc pig;
    vectorFunc v;

    atomFunc a = new atomFunc();
    int maxAtoms = 500;
	
    atom[] atomLst = new atom[maxAtoms];
    vector boxPos = new vector(400,70),
           boxSize = new vector(340,470),
           gravity = new vector(0,281000),
           l1 = new vector(850,200),
           l2 = new vector(700,240),
           circleCenter = new vector(600,170);
    float circleRadius = 50;   
	
	float deltaT = 0.001f;
	float surfBounce = 0.15f;
	float surfFriction = 0.975f;
    /*________________________________
    ___________Initialisation_______*/
    public void initialize() 
    {
        pig = new pigFunc();
        v = new vectorFunc();
        //System.out.println("vector d: " + d.x + "," + d.y);

        for (int i=0;i<1;i++)
        {
            atomLst[i] = new atom(760, 80, 60, 20);
        }
		for (int i=1;i<2;i++)
        {
            atomLst[i] = new atom(700, 80, 30, 20);
        }
		for (int i=2;i<3;i++)
        {
            atomLst[i] = new atom(730, 20, 30, 40);
        }
		for (int i=3;i<maxAtoms;i++)
        {
            atomLst[i] = new atom(840, 40, 2, 7);
        }
		
    }
    /*________________________________
    ___________Main Loop____________*/
    public void loop()
    {
        //for (float t=0;t<0.01f;t+=deltaT)    // 
        //{  
			//reset forces
			for (int i=0;i<maxAtoms;i++)
			{
				atomLst[i] = a.zeroforce(atomLst[i]);
			}

			//atom forces
			for (int i=0;i<maxAtoms-1;i++)
			{
				
				for (int j=i+1;j<maxAtoms;j++)
				{
								// if zero dist, randomize a separation vector,
								// skip repulsion and retry to solve the zero next velocity integration.
								// if the particule cannot move, it will not shake because we try
								// to separate with small random force, not position.
								// if next integration is successful in moving it so
								// having a non zero dist, dist will still be probably very small, resulting
								// in huge separation forces. all from a very small random force push.
								// it permits infinite particle at same spot, ready to explode in random pattern
								
					// if (a.near(atomLst[i], atomLst[j]) == 1			// projection sorting
					//{
						float dist = (a.distance(atomLst[i], atomLst[j]));  // returns distance, 
						
						if (dist == 0)  	
						{	
							vector separe = a.separate(atomLst[i]);
							atomLst[i] = a.addforce(atomLst[i], separe);           
							atomLst[j] = a.subforce(atomLst[j], separe);
						}
						else if (dist < a.sizes(atomLst[i], atomLst[j]))
						{						
							vector rep = a.repulse(atomLst[i], atomLst[j], dist);
							atomLst[i] = a.addforce(atomLst[i], rep);
							atomLst[j] = a.subforce(atomLst[j], rep);
						}
					
					//}
				}
			}
  
			//world forces
			for (int i=0;i<maxAtoms;i++)
			{ 
				atomLst[i] = a.gravity(atomLst[i], gravity);
				//wind
				//etc
			}
   
			//integrate
			for (int i=0;i<maxAtoms;i++)
			{
				atomLst[i] = a.integrate(atomLst[i], deltaT);
			}
   
			//hardcollision
			//termnialvelocity
			//velocitydrag
			for (int i=0;i<maxAtoms;i++)
			{ 
				atomLst[i] = a.hardcollision(atomLst[i], boxSize, boxPos, surfBounce, surfFriction);
				atomLst[i] = a.terminalvelocity(atomLst[i]);
				atomLst[i] = a.velocitydrag(atomLst[i]);
			}  
		//}
    }
    
    /*________________________________
    ___________draw_________________*/
    public void paint (Graphics g) 
    {
        //draw something
        g.setColor(Color.black);
        g.drawLine(400,60,500,60);
        g.drawString("atom Test",502,64);

//        g.setColor(Color.red);
        for (int i=0; i<maxAtoms; i++)
        {
            pig.circle(g, atomLst[i].pos,atomLst[i].radius);
        }
        
        g.setColor(Color.blue);
        pig.rect(g, boxPos, boxSize);

//        pig.circle(g, circleCenter, circleRadius);

//        pig.line(g,l1,l2);
    }
}//
