public class worldFunc{
    static vectorFunc v = new vectorFunc();
    static atomFunc a = new atomFunc();
    
    //public static void resetForce(atom[] atomLst, int maxAtoms)    // reset force accumulator
    public static world resetForce(world olWorld)    // reset force accumulator
    {
        world nuWorld = new world(olWorld);
		for (int i=0;i<olWorld.atomQty;i++)
		{
			nuWorld.append(a.zeroforce(olWorld.atomLst[i]));
		}
		return nuWorld;
    }

	// if zero dist, randomize a separation vector,
	// skip repulsion and retry to solve the zero next velocity integration.
	// if the particule cannot move, it will not shake because we try
	// to separate with small random force, not position.
	// if next integration is successful in moving it so
	// having a non zero dist, dist will still be probably very small, resulting
	// in huge separation forces. all from a very small random force push.
	// it permits infinite particle at same spot, ready to explode in random pattern
	//martin modif   now completly functional
	//in a world were A B and C interact, A move in a world were B and C havent moved
	//B move in a world were A moved but not C, then C move in a world were A and B move
	//i changed that. Now A move in a world were B and C havent move, no change.
	//B move in a world wera A and C havent moved, then C move in a world were B and A havent move
	//keep a save of the world before transformation, then transform form that data.
    public static world interAtomCollisionResponse(world olWorld)
    {
        world nuWorld = new world(olWorld);
        atom nuAtom;
		for (int i=0;i<olWorld.atomQty;i++)
		{
		    nuAtom = new atom(olWorld.atomLst[i]);
			for (int j=0; j<olWorld.atomQty; j++)
			{
			    if (i!=j)
			    {
				    float dist = (a.distance(nuAtom, olWorld.atomLst[j]));  // returns distance,
				    if (dist == 0)  	
				    {	
					    nuAtom = a.addforce(nuAtom, a.separate(nuAtom));
				    }
				    else if (dist < a.sizes(nuAtom, olWorld.atomLst[j]))
				    {						
					    nuAtom = a.addforce(nuAtom, a.repulse(nuAtom, olWorld.atomLst[j], dist));
				    }
				}
			}
			nuWorld.append(nuAtom);
		}
		return nuWorld;
    }
    
    public static world boxCollisionDetectionResponse(world olWorld)
    {
        world nuWorld = new world(olWorld);
        atom nuAtom;
		for (int i=0;i<olWorld.atomQty;i++)
		{
		    nuAtom = olWorld.atomLst[i];
			nuAtom = a.hardcollision(nuAtom, olWorld.boxSize, olWorld.boxPos, olWorld.surfBounce, olWorld.surfFriction);
			nuAtom = a.terminalvelocity(nuAtom);
			nuAtom = a.velocitydrag(nuAtom);
			nuWorld.append(nuAtom);
		}
		return nuWorld;
    }
    
    public static world environmentalForce(world olWorld)
    {
        world nuWorld = new world(olWorld);
		for (int i=0;i<olWorld.atomQty;i++)
		{ 
			nuWorld.append(a.gravity(olWorld.atomLst[i], olWorld.gravity));
			//wind
			//etc
		}
		return nuWorld;
    }
    
    public static world integrate(world olWorld, float deltaT)
    {
        world nuWorld = new world(olWorld);
		for (int i=0;i<olWorld.atomQty;i++)
		{
			nuWorld.append(a.integrate(olWorld.atomLst[i], deltaT));
		}
		return nuWorld;
    }
    

};
